Zum Hauptinhalt springen

Integration mit Svelte

Tipp

Grundkenntnisse der Konzepte und Muster von Svelte werden vorausgesetzt. Zur Auffrischung lesen Sie die Svelte-Dokumentation.

DHTMLX Pivot lässt sich als reguläre Komponente in Svelte integrieren. Ein vollständiges, funktionsfähiges Setup finden Sie in der Svelte Pivot-Demo auf GitHub.

Projekt erstellen

Info

Installieren Sie Node.js bevor Sie beginnen. Vite ist optional.

Der folgende Befehl führt das Vite-Projektgerüst-Tool aus und ermöglicht die Auswahl einer Svelte-Vorlage:

npm create vite@latest

Benennen Sie das Projekt my-svelte-pivot-app.

Abhängigkeiten installieren

Wechseln Sie in das neu erstellte Projektverzeichnis:

cd my-svelte-pivot-app

Installieren Sie die Abhängigkeiten und starten Sie den Entwicklungsserver mit Ihrem Paketmanager:

yarn 
yarn start # oder: yarn dev
npm install
npm run dev

Die App sollte auf einem lokalen Port laufen (zum Beispiel http://localhost:3000).

Pivot erstellen

Fügen Sie das Pivot-Paket zum Projekt hinzu und binden Sie Pivot anschließend in eine Svelte-Komponente ein.

Schritt 1. Paket installieren

Laden Sie das Test-Pivot-Paket herunter und folgen Sie den Schritten in der README-Datei. Das Test-Pivot-Paket ist 30 Tage gültig.

Schritt 2. Komponente erstellen

Erstellen Sie eine Svelte-Komponente, die Pivot einbindet. Fügen Sie eine neue Datei src/Pivot.svelte hinzu.

Quelldateien importieren

Öffnen Sie src/Pivot.svelte und importieren Sie die Pivot-Quelldateien. Die Import-Pfade hängen von der Paketversion ab:

  • PRO-Version (aus einem lokalen Ordner installiert):
Pivot.svelte
<script>
import { Pivot } from 'dhx-pivot-package';
import 'dhx-pivot-package/dist/pivot.css';
</script>

Wenn das Paket minimierte Assets enthält, importieren Sie pivot.min.css anstelle von pivot.css.

  • Testversion:
Pivot.svelte
<script>
import { Pivot } from '@dhx/trial-pivot';
import '@dhx/trial-pivot/dist/pivot.css';
</script>

Dieses Tutorial verwendet die Testversion von Pivot.

Container einrichten und Pivot einbinden

Um Pivot auf der Seite anzuzeigen, fügen Sie ein Container-div hinzu und initialisieren Sie Pivot dann im onMount-Lifecycle-Hook mithilfe des Konstruktors. Zerstören Sie Pivot im onDestroy-Hook.

Der folgende Code-Ausschnitt definiert eine minimale Pivot-Svelte-Komponente:

Pivot.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Pivot } from "@dhx/trial-pivot";
import "@dhx/trial-pivot/dist/pivot.css";

let container; // Container-Referenz für Pivot
let table;

onMount(() => {
// Pivot-Komponente initialisieren
table = new Pivot(container, {});
});

onDestroy(() => {
table.destructor(); // Pivot beim Unmount zerstören
});
</script>

<div bind:this={container} class="widget"></div>

Styles hinzufügen

Damit Pivot korrekt gerendert wird, fügen Sie die folgenden Styles zur CSS-Hauptdatei des Projekts hinzu:

main.css
/* Styles für die Startseite */
html,
body,
#app { /* #app-Root-Container verwenden */
height: 100%;
padding: 0;
margin: 0;
}

/* Styles für den Pivot-Container */
.widget {
height: 100%;
width: 100%;
}

Daten laden

Um Pivot mit Daten zu versorgen, bereiten Sie einen Datensatz vor. Erstellen Sie src/data.js und exportieren Sie die Daten und Feld-Metadaten:

data.js
export function getData() {
const dataset = [
{
"cogs": 51,
"date": "10/1/2018",
"inventory_margin": 503,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 46,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Lemon",
"profit": -5,
"sales": 122,
"state": "Colorado",
"expenses": 76,
"type": "Decaf"
},
{
"cogs": 52,
"date": "10/1/2018",
"inventory_margin": 405,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 17,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Mint",
"profit": 26,
"sales": 123,
"state": "Colorado",
"expenses": 45,
"type": "Decaf"
}, // weitere Datensätze
];

const fields = [
{
"id": "cogs",
"label": "Cogs",
"type": "number"
},
{
"id": "date",
"label": "Date",
"type": "date"
}, // weitere Felder
];

return { dataset, fields };
};

Öffnen Sie src/App.svelte, importieren Sie die Daten und übergeben Sie sie als Props an die neue <Pivot/>-Komponente:

App.svelte
<script>
import Pivot from "./Pivot.svelte";
import { getData } from "./data.js";

const { fields, dataset } = getData();
</script>

<Pivot fields={fields} dataset={dataset} />

Öffnen Sie src/Pivot.svelte, deklarieren Sie die eingehenden Props mit export let und wenden Sie sie auf das Pivot-Konfigurationsobjekt an:

Pivot.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Pivot } from "@dhx/trial-pivot";
import "@dhx/trial-pivot/dist/pivot.css";

export let fields;
export let dataset;

let container;
let table;

onMount(() => {
table = new Pivot(container, {
fields,
data: dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // weitere Werte
]
},
// weitere Konfigurationseigenschaften
});
});

onDestroy(() => {
table.destructor();
});
</script>

<div bind:this={container} class="widget"></div>

Die Komponente ist nun einsatzbereit. Beim Einbinden rendert Pivot mit den übergebenen Daten. Die vollständige Liste der Konfigurationseigenschaften finden Sie in der Pivot-API-Dokumentation.

Events behandeln

Benutzeraktionen in Pivot lösen Events aus, die Sie abonnieren können. Die vollständige Liste der Events finden Sie in der Übersicht der Events.

Der folgende Code-Ausschnitt erweitert onMount um einen open-filter-Event-Listener, der die Feld-ID protokolliert, wenn ein Benutzer einen Filter öffnet:

Pivot.svelte
<script>
// ...
let table;

onMount(() => {
table = new Pivot(container, {
fields,
data: dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // weitere Werte
]
},
// weitere Konfigurationseigenschaften
});

table.api.on("open-filter", (ev) => {
console.log("Die Feld-ID, für die der Filter aktiviert wurde:", ev.id);
});
});

onDestroy(() => {
table.destructor();
});
</script>

// ...

Starten Sie die App, um zu sehen, wie Pivot die Daten auf der Seite rendert.

Pivot-Initialisierung

Pivot ist nun in Svelte integriert. Passen Sie die Konfiguration an die Anforderungen Ihres Projekts an. Das vollständige Beispiel finden Sie in der svelte-pivot-demo auf GitHub.

Zum Hauptinhalt springen

Integration mit Vue

Tipp

Grundkenntnisse der Konzepte und Muster von Vue werden vorausgesetzt. Zur Auffrischung lesen Sie die Vue-3-Dokumentation.

DHTMLX Pivot lässt sich als reguläre Komponente in Vue einbinden. Ein vollständiges Arbeitsbeispiel finden Sie in der Vue-Pivot-Demo auf GitHub.

Projekt erstellen

Info

Installieren Sie Node.js, bevor Sie beginnen.

Der folgende Befehl startet das offizielle Vue-Projektgerüst-Tool:

npm create vue@latest

Der Befehl installiert und führt create-vue aus. Weitere Informationen finden Sie im Vue.js Quick Start.

Nennen Sie das Projekt my-vue-pivot-app.

Abhängigkeiten installieren

Wechseln Sie in das neue Projektverzeichnis:

cd my-vue-pivot-app

Installieren Sie die Abhängigkeiten und starten Sie den Entwicklungsserver mit Ihrem Paketmanager:

yarn
yarn start # oder: yarn dev
npm install
npm run dev

Die App sollte auf einem lokalen Port verfügbar sein (zum Beispiel http://localhost:3000).

Pivot erstellen

Fügen Sie das Pivot-Paket zum Projekt hinzu und binden Sie Pivot in eine Vue-Komponente ein.

Schritt 1. Paket installieren

Laden Sie das Pivot-Testpaket herunter und befolgen Sie die Schritte in der README. Das Pivot-Testpaket ist 30 Tage gültig.

Schritt 2. Komponente erstellen

Erstellen Sie eine Vue-Komponente, die Pivot einbindet. Legen Sie die neue Datei src/components/Pivot.vue an.

Quelldateien importieren

Öffnen Sie src/components/Pivot.vue und importieren Sie die Pivot-Quelldateien. Die Import-Pfade hängen von der Paketedition ab:

  • PRO-Version (aus einem lokalen Ordner installiert):
Pivot.vue
<script>
import { Pivot } from 'dhx-pivot-package';
import 'dhx-pivot-package/dist/pivot.css';
</script>

Falls das Paket minimierte Assets enthält, importieren Sie pivot.min.css statt pivot.css.

  • Testversion:
Pivot.vue
<script>
import { Pivot } from '@dhx/trial-pivot';
import '@dhx/trial-pivot/dist/pivot.css';
</script>

Dieses Tutorial verwendet die Testversion von Pivot.

Container einrichten und Pivot einbinden

Um Pivot auf der Seite anzuzeigen, fügen Sie ein Container-div hinzu und initialisieren Sie Pivot im mounted-Hook mithilfe des Konstruktors. Zerstören Sie Pivot im unmounted-Hook.

Der folgende Code-Ausschnitt definiert eine minimale Pivot-Vue-Komponente:

Pivot.vue
<script>
import { Pivot } from "@dhx/trial-pivot";
import "@dhx/trial-pivot/dist/pivot.css";

export default {
mounted() {
// Pivot-Komponente initialisieren
this.table = new Pivot(this.$refs.container, {});
},

unmounted() {
this.table.destructor(); // Pivot beim Unmount zerstören
}
};
</script>

<template>
<div ref="container" class="widget"></div>
</template>

Styles hinzufügen

Damit Pivot korrekt gerendert wird, fügen Sie die folgenden Styles in die CSS-Hauptdatei des Projekts ein:

style.css
/* Styles für die initiale Seite */
html,
body,
#app { /* den #app-Root-Container verwenden */
height: 100%;
padding: 0;
margin: 0;
}

/* Styles für den Pivot-Container */
.widget {
width: 100%;
height: 100%;
}

Daten laden

Um Daten in Pivot zu laden, bereiten Sie einen Datensatz vor. Erstellen Sie src/data.js und exportieren Sie die Daten sowie die Feld-Metadaten:

data.js
export function getData() {
const dataset = [
{
"cogs": 51,
"date": "10/1/2018",
"inventory_margin": 503,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 46,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Lemon",
"profit": -5,
"sales": 122,
"state": "Colorado",
"expenses": 76,
"type": "Decaf"
},
{
"cogs": 52,
"date": "10/1/2018",
"inventory_margin": 405,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 17,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Mint",
"profit": 26,
"sales": 123,
"state": "Colorado",
"expenses": 45,
"type": "Decaf"
}, // weitere Dateneinträge
];

const fields = [
{
"id": "cogs",
"label": "Cogs",
"type": "number"
},
{
"id": "date",
"label": "Date",
"type": "date"
}, // weitere Felder
];

return { dataset, fields };
};

Öffnen Sie src/App.vue, importieren Sie die Daten, und stellen Sie sie über die data()-Option bereit. Übergeben Sie die Werte dann als Props an die neue <Pivot/>-Komponente:

App.vue
<script>
import Pivot from "./components/Pivot.vue";
import { getData } from "./data";

export default {
components: { Pivot },
data() {
const { fields, dataset } = getData();
return {
fields,
dataset
};
}
};
</script>

<template>
<Pivot :fields="fields" :dataset="dataset" />
</template>

Öffnen Sie src/components/Pivot.vue, deklarieren Sie die eingehenden Props, und wenden Sie sie auf das Pivot-Konfigurationsobjekt an:

Pivot.vue
<script>
import { Pivot } from "@dhx/trial-pivot";
import "@dhx/trial-pivot/dist/pivot.css";

export default {
props: ["fields", "dataset"],

mounted() {
this.table = new Pivot(this.$refs.container, {
fields: this.fields,
data: this.dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // weitere Werte
]
},
// weitere Konfigurationseigenschaften
});
},

unmounted() {
this.table.destructor();
}
};
</script>

<template>
<div ref="container" class="widget"></div>
</template>

Die Komponente ist nun einsatzbereit. Beim Einbinden rendert Pivot mit den übergebenen Daten. Die vollständige Liste der Konfigurationseigenschaften finden Sie in der Pivot-API-Dokumentation.

Events verarbeiten

Benutzeraktionen in Pivot lösen Events aus, die Sie abonnieren können. Die vollständige Liste der Events finden Sie in der Events-Übersicht.

Der folgende Code-Ausschnitt erweitert mounted um einen open-filter-Event-Listener, der die Feld-ID protokolliert, wenn ein Benutzer einen Filter öffnet:

Pivot.vue
<script>
// ...
export default {
// ...
mounted() {
this.table = new Pivot(this.$refs.container, {
fields: this.fields,
data: this.dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // weitere Werte
]
},
// weitere Konfigurationseigenschaften
});

this.table.api.on("open-filter", (ev) => {
console.log("Die Feld-ID, für die der Filter aktiviert wird:", ev.id);
});
}
// ...
}
</script>

// ...

Starten Sie die App, um zu sehen, wie Pivot die Daten auf der Seite rendert.

Pivot-Initialisierung

Pivot ist nun in Vue integriert. Passen Sie die Konfiguration an die Anforderungen Ihres Projekts an. Das vollständige Beispiel finden Sie in der vue-pivot-Demo auf GitHub.

Zum Hauptinhalt springen

Integration mit React

Tipp

Es werden grundlegende Kenntnisse der Konzepte und Muster von React vorausgesetzt. Zur Auffrischung empfiehlt sich die React-Dokumentation.

DHTMLX Pivot lässt sich als reguläre Komponente in React integrieren. Ein vollständiges Beispiel-Setup finden Sie in der React Pivot Demo auf GitHub.

Projekt erstellen

Info

Installieren Sie Node.js, bevor Sie beginnen. Vite ist optional.

Erstellen Sie ein einfaches React-Projekt (oder ein Vite-basiertes) mit dem Namen my-react-pivot-app.

Der folgende Befehl richtet ein Create React App-Projekt ein:

npx create-react-app my-react-pivot-app

Abhängigkeiten installieren

Wechseln Sie in das neue Projektverzeichnis:

cd my-react-pivot-app

Installieren Sie die Abhängigkeiten und starten Sie den Dev-Server mit Ihrem Paketmanager:

yarn
yarn start # oder: yarn dev
npm install
npm run dev

Die Anwendung sollte auf einem lokalen Port laufen (beispielsweise http://localhost:3000).

Pivot erstellen

Fügen Sie das Pivot-Paket zum Projekt hinzu und umschließen Sie Pivot anschließend mit einer React-Komponente.

Schritt 1. Paket installieren

Laden Sie das Pivot-Testpaket herunter und folgen Sie den Schritten in der README. Das Pivot-Testpaket ist 30 Tage gültig.

Schritt 2. Komponente erstellen

Erstellen Sie eine React-Komponente, die Pivot einbindet. Legen Sie eine neue Datei src/Pivot.jsx an.

Quelldateien importieren

Öffnen Sie src/Pivot.jsx und importieren Sie die Pivot-Quelldateien. Die Import-Pfade hängen von der Paketedition ab:

  • PRO-Version (aus einem lokalen Ordner installiert):
Pivot.jsx
import { Pivot } from 'dhx-pivot-package';
import 'dhx-pivot-package/dist/pivot.css';

Falls das Paket minifizierte Assets enthält, importieren Sie statt pivot.css die Datei pivot.min.css.

  • Testversion:
Pivot.jsx
import { Pivot } from '@dhx/trial-pivot';
import "@dhx/trial-pivot/dist/pivot.css";

Dieses Tutorial verwendet die Testversion von Pivot.

Container einrichten und Pivot einbinden

Um Pivot auf der Seite anzuzeigen, erstellen Sie ein Container-div und initialisieren Sie Pivot anschließend in einem useEffect-Hook mithilfe des Konstruktors.

Das folgende Code-Snippet definiert eine minimale Pivot-React-Komponente:

Pivot.jsx
import { useEffect, useRef } from "react";
import { Pivot } from "@dhx/trial-pivot";
import "@dhx/trial-pivot/dist/pivot.css"; // Pivot-Styles einbinden

export default function PivotComponent(props) {
let container = useRef(); // Container-Ref für Pivot

useEffect(() => {
// die Pivot-Komponente initialisieren
const table = new Pivot(container.current, {});

return () => {
table.destructor(); // Pivot beim Unmount zerstören
};
}, []);

return <div ref={container} className="widget"></div>;
}

Styles hinzufügen

Damit Pivot korrekt dargestellt wird, fügen Sie die folgenden Styles zur CSS-Hauptdatei des Projekts hinzu:

index.css
/* Styles für die Ausgangsseite */
html,
body,
#root {
height: 100%;
padding: 0;
margin: 0;
}

/* Styles für den Pivot-Container */
.widget {
height: 100%;
width: 100%;
}

Daten laden

Um Pivot mit Daten zu versorgen, bereiten Sie einen Datensatz vor. Erstellen Sie src/data.js und exportieren Sie die Daten sowie die Feld-Metadaten:

data.js
export function getData() {
const dataset = [
{
"cogs": 51,
"date": "10/1/2018",
"inventory_margin": 503,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 46,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Lemon",
"profit": -5,
"sales": 122,
"state": "Colorado",
"expenses": 76,
"type": "Decaf"
},
{
"cogs": 52,
"date": "10/1/2018",
"inventory_margin": 405,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 17,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Mint",
"profit": 26,
"sales": 123,
"state": "Colorado",
"expenses": 45,
"type": "Decaf"
}, // weitere Dateneinträge
];

const fields = [
{
"id": "cogs",
"label": "Cogs",
"type": "number"
},
{
"id": "date",
"label": "Date",
"type": "date"
}, // weitere Felder
];

return { dataset, fields };
};

Öffnen Sie src/App.js, importieren Sie die Daten und übergeben Sie diese als Props an die <Pivot/>-Komponente:

App.js
import Pivot from "./Pivot";
import { getData } from "./data";

function App() {
const { fields, dataset } = getData();
return <Pivot fields={fields} dataset={dataset} />;
}

export default App;

Öffnen Sie src/Pivot.jsx, destrukturieren Sie die Props und wenden Sie diese auf das Pivot-Konfigurationsobjekt an:

Pivot.jsx
import { useEffect, useRef } from "react";
import { Pivot } from "@dhx/trial-pivot";
import "@dhx/trial-pivot/dist/pivot.css";

export default function PivotComponent({ fields, dataset }) {
let container = useRef();

useEffect(() => {
const table = new Pivot(container.current, {
fields,
data: dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // weitere Werte
]
},
// weitere Konfigurationseigenschaften
});

return () => {
table.destructor();
}
}, []);

return <div ref={container} className="widget"></div>;
}

Die Komponente ist nun einsatzbereit. Beim Einbinden rendert Pivot mit den bereitgestellten Daten. Die vollständige Liste der Konfigurationseigenschaften finden Sie in der Pivot-API-Dokumentation.

Events verarbeiten

Benutzeraktionen in Pivot lösen Events aus, die Sie abonnieren können. Die vollständige Liste der Events finden Sie in der Events-Übersicht.

Das folgende Code-Snippet erweitert useEffect um einen open-filter-Event-Listener, der die Feld-ID protokolliert, wenn ein Benutzer einen Filter öffnet:

Pivot.jsx
// ...
useEffect(() => {
const table = new Pivot(container.current, {
fields,
data: dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // weitere Werte
]
},
// weitere Konfigurationseigenschaften
});

table.api.on("open-filter", (ev) => {
console.log("Die Feld-ID, für die der Filter aktiviert wurde:", ev.id);
});

return () => {
table.destructor();
}
}, []);
// ...

Starten Sie die Anwendung, um zu sehen, wie Pivot die Daten auf der Seite rendert.

Pivot-Initialisierung

Pivot ist nun in React integriert. Passen Sie die Konfiguration an die Projektanforderungen an. Das vollständige Beispiel finden Sie in der react-pivot-demo auf GitHub.

Zum Hauptinhalt springen

Integration mit Angular

Tipp

Grundkenntnisse der Konzepte und Muster von Angular werden vorausgesetzt. Zur Auffrischung lesen Sie die Angular-Dokumentation.

DHTMLX Pivot lässt sich wie eine reguläre Komponente in Angular einbinden. Ein vollständiges, lauffähiges Beispiel finden Sie in der Angular Pivot Demo auf GitHub.

Projekt erstellen

Info

Installieren Sie Angular CLI und Node.js, bevor Sie beginnen.

Der folgende Befehl erstellt ein neues Angular-Projekt mit dem Namen my-angular-pivot-app:

ng new my-angular-pivot-app
Hinweis

Deaktivieren Sie Server-Side Rendering (SSR) und Static Site Generation (SSG/Prerendering), wenn die Angular CLI danach fragt — dieser Guide setzt eine client-seitig gerenderte App voraus.

Der Befehl installiert alle erforderlichen Werkzeuge. Weitere Befehle sind nicht notwendig.

Abhängigkeiten installieren

Wechseln Sie in das neue Projektverzeichnis:

cd my-angular-pivot-app

Installieren Sie die Abhängigkeiten und starten Sie den Entwicklungsserver mit dem Paketmanager yarn:

yarn
yarn start # oder: yarn dev

Die App sollte auf einem lokalen Port erreichbar sein (zum Beispiel http://localhost:3000).

Pivot erstellen

Fügen Sie das Pivot-Paket zum Projekt hinzu und binden Sie Pivot anschließend in eine Angular-Komponente ein.

Schritt 1. Paket installieren

Laden Sie das Pivot-Testpaket herunter und folgen Sie den Anweisungen in der README-Datei. Das Testpaket ist 30 Tage gültig.

Schritt 2. Komponente erstellen

Erstellen Sie eine Angular-Komponente, die Pivot einbindet. Legen Sie einen Ordner pivot unter src/app/ an und erstellen Sie die Datei src/app/pivot/pivot.component.ts. Folgen Sie dann diesen Schritten:

Quelldateien importieren

Öffnen Sie src/app/pivot/pivot.component.ts und importieren Sie das Pivot-Paket. Der Import-Pfad hängt von der Paketedition ab:

  • PRO-Version (aus einem lokalen Ordner installiert):
import { Pivot } from 'dhx-pivot-package';
  • Testversion:
import { Pivot } from '@dhx/trial-pivot';

Dieses Tutorial verwendet die Testversion von Pivot.

Container einrichten und Pivot einbinden

Um Pivot auf der Seite anzuzeigen, definieren Sie ein Container-Element im Component-Template und initialisieren Sie Pivot im ngOnInit-Hook über den Konstruktor. Zerstören Sie Pivot im ngOnDestroy-Hook.

Das folgende Code-Snippet definiert eine minimale Pivot Angular-Komponente:

pivot.component.ts
import { Pivot } from '@dhx/trial-pivot';
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation } from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "pivot", // Template-Name, der in "app.component.ts" als <pivot /> verwendet wird
styleUrls: ["./pivot.component.css"], // CSS-Datei einbinden
template: `<div #container className="widget"></div>`,
})

export class PivotComponent implements OnInit, OnDestroy {
// Container-Referenz für Pivot
@ViewChild('container', { static: true }) pivot_container!: ElementRef;

private _table!: Pivot;

ngOnInit() {
// Pivot-Komponente initialisieren
this._table = new Pivot(this.pivot_container.nativeElement, {});
}

ngOnDestroy(): void {
this._table.destructor(); // Pivot beim Entfernen zerstören
}
}

Stile hinzufügen

Damit Pivot korrekt gerendert wird, erstellen Sie src/app/pivot/pivot.component.css mit Stilen für die Seite und den Pivot-Container:

pivot.component.css
/* Pivot-Stile importieren */
@import "@dhx/trial-pivot/dist/pivot.css";

/* Stile für die Startseite */
html,
body {
margin: 0;
padding: 0;
height: 100%;
}

/* Stile für den Pivot-Container */
.widget {
width: 100%;
height: 100%;
}

Daten laden

Um Pivot mit Daten zu versorgen, bereiten Sie einen Datensatz vor. Erstellen Sie src/app/pivot/data.ts und exportieren Sie die Daten sowie die Feld-Metadaten:

data.ts
export function getData() {
const dataset = [
{
"cogs": 51,
"date": "10/1/2018",
"inventory_margin": 503,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 46,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Lemon",
"profit": -5,
"sales": 122,
"state": "Colorado",
"expenses": 76,
"type": "Decaf"
},
{
"cogs": 52,
"date": "10/1/2018",
"inventory_margin": 405,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 17,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Mint",
"profit": 26,
"sales": 123,
"state": "Colorado",
"expenses": 45,
"type": "Decaf"
}, // weitere Datensätze
];

const fields: any = [
{
"id": "cogs",
"label": "Cogs",
"type": "number"
},
{
"id": "date",
"label": "Date",
"type": "date"
}, // weitere Felder
];

return { dataset, fields };
};

Öffnen Sie src/app/pivot/pivot.component.ts, importieren Sie getData und wenden Sie den Datensatz in ngOnInit() an:

pivot.component.ts
import { Pivot } from '@dhx/trial-pivot';
import { getData } from "./data"; // Daten importieren
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation } from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "pivot",
styleUrls: ["./pivot.component.css"],
template: `<div #container className="widget"></div>`,
})

export class PivotComponent implements OnInit, OnDestroy {
@ViewChild('container', { static: true }) pivot_container!: ElementRef;

private _table!: Pivot;

ngOnInit() {
const { dataset, fields } = getData(); // Daten und Feld-Metadaten entpacken
this._table = new Pivot(this.pivot_container.nativeElement, {
fields,
data: dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // weitere Werte
]
},
// weitere Konfigurationseigenschaften
});
}

ngOnDestroy(): void {
this._table.destructor();
}
}

Die Komponente ist jetzt einsatzbereit. Beim Einbinden rendert Pivot die übergebenen Daten. Die vollständige Liste der Konfigurationseigenschaften finden Sie in der Pivot API-Dokumentation.

Events behandeln

Benutzeraktionen in Pivot lösen Events aus, die Sie abonnieren können. Die vollständige Liste der Events finden Sie in der Events-Übersicht.

Das folgende Code-Snippet erweitert ngOnInit um einen open-filter-Event-Listener, der die Feld-ID protokolliert, wenn ein Benutzer einen Filter öffnet:

pivot.component.ts
// ...
ngOnInit() {
const { dataset, fields } = getData();
this._table = new Pivot(this.pivot_container.nativeElement, {
fields,
data: dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // weitere Werte
]
}
});

this._table.api.on("open-filter", (ev) => {
console.log("Die Feld-ID, für die der Filter aktiviert wird:", ev.id);
});
}

ngOnDestroy(): void {
this._table.destructor();
}

Schritt 3. Pivot zur App hinzufügen

Um PivotComponent in die App einzubetten, öffnen Sie src/app/app.component.ts und ersetzen Sie den Standardcode durch Folgendes:

app.component.ts
import { Component } from "@angular/core";

@Component({
selector: "app-root",
template: `<pivot/>` // Template, das in "pivot.component.ts" erstellt wurde
})
export class AppComponent {
name = "";
}

Erstellen Sie dann src/app/app.module.ts und registrieren Sie PivotComponent:

app.module.ts
import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";

import { AppComponent } from "./app.component";
import { PivotComponent } from "./pivot/pivot.component";

@NgModule({
declarations: [AppComponent, PivotComponent],
imports: [BrowserModule],
bootstrap: [AppComponent]
})
export class AppModule {}

Öffnen Sie abschließend src/main.ts und ersetzen Sie den Inhalt durch folgenden Bootstrap-Code:

main.ts
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
platformBrowserDynamic()
.bootstrapModule(AppModule)
.catch((err) => console.error(err));

Starten Sie die App, um zu sehen, wie Pivot die Daten auf der Seite rendert.

Pivot-Initialisierung

Pivot ist nun in Angular integriert. Passen Sie die Konfiguration an die Anforderungen Ihres Projekts an. Das vollständige Beispiel finden Sie in der angular-pivot-demo auf GitHub.